﻿
Public Class Form1

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Me.Text = AppTitleAndVersion()
        OpenAllThereminicApps()
        ' -------------------------------------------------
        RTB.PaintEventEnabled = False
        RTB.Enabled = False
        Load_INI()
        LoadFile()
        RTB_Lines = RTB.Lines
        RTB.InitProps()
        RTB.ColorAllLines()
        ShowHideControls()
        ' ------------------------------------------------- 
        RTB.Undo_Clear()
        RTB.SelectionStart = 0
        RTB.SelectionLength = 0
        RTB.Enabled = True
        RTB.PaintEventEnabled = True
        ApplyEditorProps()
        ' -------------------------------------------------
        RTB_Lines = RTB.Lines
        ReinitTransferLists(RTB_Lines)
        RestartCommAndThread()
        Timer1.Interval = 100
        Timer1.Start()
        ToolTips_Init()
        EventsAreEnabled = True
        ' -------------------------------------------------
        Me.Refresh()
        SetFormOpacity()
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        Save_INI()
        CloseAllOpenedProcesses()
        Timer1.Stop()
        FastTimer_Stop()
        COM_Close()
    End Sub

    Private Sub Form1_LocationChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.LocationChanged
        If Not EventsAreEnabled Then Return
        LimitFormPosition(Me)
    End Sub

    Private Sub Form1_ResizeEnd(ByVal sender As Object, ByVal e As EventArgs) Handles Me.ResizeEnd
        RTB.Invalidate()
    End Sub

    Private Sub Form1_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        If Not EventsAreEnabled Then Return
        ShowHideTextAndTools()
    End Sub

    Private Sub GroupBox1_MouseClick(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles GroupBox1.MouseClick
        If e.Location.Y > RTB.Top Then Return
        If e.Location.X > chk_Comment.Left - 16 Then Return
        If Not EventsAreEnabled Then Return
        SaveCommandsFile()
        LoadFileDialog()
        LoadFile()
        ApplyEditorProps(True)
        Save_INI()
        RTB_Lines = RTB.Lines
        ReinitTransferLists(RTB_Lines)
    End Sub

    ' -----------------------------------------------------------------------------------------------------
    '  COM PORT 
    ' ----------------------------------------------------------------------------------------------------- 
    Private Sub cmb_ComPort_DropDown(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_ComPort.DropDown
        SetComboColors(True)
        ComPortAddItems
    End Sub
    Private Sub ComPortAddItems()
        cmb_ComPort.Items.Clear()
        For Each s As String In COM_GetPortNames()
            cmb_ComPort.Items.Add(s)
        Next
    End Sub
    Private Sub cmb_ComPort_DropDownClosed(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_ComPort.DropDownClosed
        If cmb_ComPort.SelectedIndex >= 0 And cmb_ComPort.Items.Count >= 1 Then
            cmb_ComPort.Text = cmb_ComPort.Items(cmb_ComPort.SelectedIndex).ToString
            Save_INI()
        End If
        RestartCommAndThread()
        chk_Connected.Focus()
        RTB_Lines = RTB.Lines
        ReinitTransferLists(RTB_Lines)
    End Sub

    Private Sub cmb_ComSpeed_DropDown(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_ComSpeed.DropDown
        SetBaudrateComboItems()
    End Sub
    Private Sub cmb_ComSpeed_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles cmb_ComSpeed.KeyDown
        OnlyNumericComboBox(sender, e)
    End Sub
    Private Sub cmb_ComSpeed_DropDownClosed(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_ComSpeed.DropDownClosed
        cmb_ComSpeed.Text = cmb_ComSpeed.Items(cmb_ComSpeed.SelectedIndex).ToString
        Save_INI()
        RestartCommAndThread()
        chk_Connected.Focus()
        RTB_Lines = RTB.Lines
        ReinitTransferLists(RTB_Lines)
    End Sub

    Private Sub RestartCommAndThread()
        FastTimer_Stop()
        COM_Close()
        BroadcastBaudrate(cmb_ComPort.Text, StringToInt32(cmb_ComSpeed.Text))
        COM_Open(cmb_ComPort.Text, StringToInt32(cmb_ComSpeed.Text))
        FastTimer_Start()
        SetComboColors(ComPort.IsOpen)
    End Sub

    Private Sub SetComboColors(ByVal ok As Boolean)
        Dim c As Color
        If ok Then
            c = Color.WhiteSmoke
            c = Color.FromArgb(230, 255, 200)
        Else
            c = Color.FromArgb(240, 150, 100)
        End If
        cmb_ComPort.BackColor = c
        cmb_ComSpeed.BackColor = c
    End Sub

    Private Sub chk_AutoReconnect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        If chk_Reconnect.Checked Then
            MessageBox.Show("WARNING - This test is done on the return packets." + vbCrLf + vbCrLf + _
                            "If your commands are all without return packets" + vbCrLf + _
                            "do not set this option, or you will get continue retries.", _
                            "Message from Theremino-ModBus", _
                            MessageBoxButtons.OK, MessageBoxIcon.Warning)
        End If
        ShowHideControls()
    End Sub

    Private Sub ShowHideControls()
        chk_ScanPorts.Visible = chk_Reconnect.Checked
    End Sub


    ' =============================================================================================
    '  SHOW and HIDE Text and TOOLS
    ' ============================================================================================= 
    Friend Sub ShowHideTextAndTools()
        ' --------------------------------------------------------------------- hide/show program text
        Dim GBoxProgramTextLength As Single
        Dim txt As String = IO.Path.GetFileNameWithoutExtension(CommandsFileName)
        GBoxProgramTextLength = TextRenderer.MeasureText(txt, GroupBox1.Font).Width
        If GBoxProgramTextLength + 10 < chk_Comment.Left Then
            GroupBox1.Text = txt
        Else
            GroupBox1.Text = ""
        End If
        ' --------------------------------------------------------------------- hide/show tools
        chk_Comment.Visible = chk_Comment.Left > 10
        chk_Uncomment.Visible = chk_Uncomment.Left > 10
        chk_Undo.Visible = chk_Undo.Left > 10
        chk_Redo.Visible = chk_Redo.Left > 10
        chk_HistoryBack.Visible = chk_HistoryBack.Left > 10
        chk_HistoryForward.Visible = chk_HistoryForward.Left > 10
        chk_GoToNextOccurrence.Visible = chk_GoToNextOccurrence.Left > 10
        chk_GotoDeclaration.Visible = chk_GotoDeclaration.Left > 10
        chk_Options.Visible = chk_Options.Left > 10
        chk_Help.Visible = chk_Help.Left > 10
        ' --------------------------------------------------------------------- hide/show label_lines
        Label_Lines.Visible = Label_Lines.Left > tkbar_Transparency.Right
        ' --------------------------------------------------------------------- hide/show zoom and opacity
        tkbar_Zoom.Visible = tkbar_Zoom.Right + 10 < GroupBox1.Width
        tkbar_Transparency.Visible = tkbar_Transparency.Right + 10 < GroupBox1.Width
    End Sub

    ' =============================================================================================
    '  MenuStrip, ToolStrip and RichTextBox accepting the first click
    '  If the form is not focused and receives a WM_PARENTNOTIFY (528) message
    '  then the form is activated before to exec the message
    ' =============================================================================================
    <DebuggerStepThrough()> _
    Protected Overrides Sub WndProc(ByRef m As Message)
        If m.Msg = 528 AndAlso Not Me.Focused Then
            Me.Activate()
        End If
        MyBase.WndProc(m)
    End Sub


    ' ===========================================================================================================
    '   TIMERS
    ' ===========================================================================================================
    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        ' 
        Statistics_Update()
        '
        If Stat_Working < 2 Then
            chk_Connected.Text = "Inactive"
            chk_Connected.BackColor = Color.FromArgb(100, 130, 0)
            chk_Connected.ForeColor = Color.White
            TryToReconnect
        ElseIf Stat_FPS < 5 Then
            chk_Connected.Text = "Disconnected"
            chk_Connected.BackColor = Color.FromArgb(200, 100, 0)
            chk_Connected.ForeColor = Color.White
            TryToReconnect()
        Else
            chk_Connected.Text = "FPS " + Stat_FPS.ToString("0")
            chk_Connected.BackColor = Color.FromArgb(180, 255, 50)
            chk_Connected.ForeColor = Color.Black
        End If
        ' 
        UpdateSectionSelector()
    End Sub

    Private Sub TryToReconnect()
        If chk_Reconnect.Checked Then
            '
            Static ReconnectCounter As Int32
            ReconnectCounter += 1
            If ReconnectCounter < 5 Then Return
            ReconnectCounter = 0
            '
            Timer1.Stop()
            chk_Connected.Text = "RETRYING"
            chk_Connected.BackColor = Color.FromArgb(180, 255, 50)
            chk_Connected.ForeColor = Color.Black
            chk_Connected.Refresh()
            '
            COM_Close()
            '
            If chk_ScanPorts.Checked Then
                Static ComIndex As Int32
                ComPortAddItems()
                If cmb_ComPort.Items.Count > 0 Then
                    If ComIndex < cmb_ComPort.Items.Count - 1 Then
                        ComIndex += 1
                    Else
                        ComIndex = 0
                    End If
                    cmb_ComPort.SelectedIndex = ComIndex
                End If
            End If
            '
            BroadcastBaudrate(cmb_ComPort.Text, CInt(Val(cmb_ComSpeed.Text)))
            COM_Open(cmb_ComPort.Text, CInt(Val(cmb_ComSpeed.Text)))
            SetComboColors(ComPort.IsOpen)
            Timer1.Start()
            '
            ReinitTransferLists(RTB_Lines)
        End If
    End Sub


    ' -----------------------------------------------------------------------------------------------------
    '  TOOLS
    ' -----------------------------------------------------------------------------------------------------
    Private Sub chk_Comment_Click(ByVal sender As Object, ByVal e As EventArgs) Handles chk_Comment.Click
        RTB.CommentSelectedLines(True)
        RTB.Focus()
    End Sub
    Private Sub chk_Uncomment_Click(ByVal sender As Object, ByVal e As EventArgs) Handles chk_Uncomment.Click
        RTB.CommentSelectedLines(False)
        RTB.Focus()
    End Sub
    Private Sub chk_Undo_Click(ByVal sender As Object, ByVal e As EventArgs) Handles chk_Undo.Click
        RTB.ExecUndo()
        'ApplyEditorProps(True)  ' can not do this here because it moves the caret to start page
        RTB.Focus()
    End Sub
    Private Sub chk_Redo_Click(ByVal sender As Object, ByVal e As EventArgs) Handles chk_Redo.Click
        RTB.ExecRedo()
        'ApplyEditorProps(True)  ' can not do this here because it moves the caret to start page
        RTB.Focus()
    End Sub
    Private Sub chk_HistoryBack_Click(ByVal sender As Object, ByVal e As EventArgs) Handles chk_HistoryBack.Click
        RTB.History_Back()
        RTB.Focus()
    End Sub
    Private Sub chk_HistoryForward_Click(ByVal sender As Object, ByVal e As EventArgs) Handles chk_HistoryForward.Click
        RTB.History_Forward()
        RTB.Focus()
    End Sub
    Private Sub chk_GotoNextWordOccurrence_Click(ByVal sender As Object, ByVal e As EventArgs) Handles chk_GoToNextOccurrence.Click
        RTB.GoToNextOccurrence()
        RTB.Focus()
    End Sub
    Private Sub chk_GotoDeclaration_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles chk_GotoDeclaration.Click
        RTB.GoToDeclaration()
        RTB.Focus()
    End Sub
    Private Sub chk_Options_Click(ByVal sender As Object, ByVal e As EventArgs) Handles chk_Options.Click
        If Form_Options.Visible Then
            Form_Options.Hide()
        Else
            Form_Options.Location = New Point(Cursor.Position.X - 400, Cursor.Position.Y + 20)
            Form_Options.Show()
        End If
    End Sub
    Private Sub chk_Help_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles chk_Help.MouseDown
        If e.Button = Windows.Forms.MouseButtons.Left Then
            OpenHelpFile()
        Else
            LocateHelpFile()
        End If
    End Sub


    ' =============================================================================================
    '  CONTEXTUAL MENU - EDITOR
    ' =============================================================================================
    Private RTB_MousePos As Point
    Private Sub MenuStrip_Edit_Opening(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MenuStrip_Edit.Opening
        RTB_MousePos = RTB.PointToClient(MousePosition)
        If RTB_MousePos.Y < 0 Then e.Cancel = True : Return
        MenuStrip_Edit.Show(RTB, RTB_MousePos.X + 20, RTB_MousePos.Y + 10)
    End Sub
    Private Sub MenuStrip_Edit_Comment_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuStrip_Edit_Comment.Click
        RTB.CommentSelectedLines(True)
    End Sub
    Private Sub MenuStrip_Edit_Uncomment_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuStrip_Edit_Uncomment.Click
        RTB.CommentSelectedLines(False)
    End Sub
    Private Sub MenuStrip_Edit_GoBack_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuStrip_Edit_GoBack.Click
        RTB.History_Back()
        RTB.Focus()
    End Sub
    Private Sub MenuStrip_Edit_GoForward_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuStrip_Edit_GoForward.Click
        RTB.History_Forward()
        RTB.Focus()
    End Sub
    Private Sub MenuStrip_Edit_GotoNextWordOccurrence_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuStrip_Edit_GoToNextOccurrence.Click
        RTB.GoToNextOccurrence()
    End Sub
    Private Sub MenuStrip_Edit_GotoDeclaration_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuStrip_Edit_GoToDeclaration.Click
        RTB.GoToDeclaration()
    End Sub
    Private Sub MenuStrip_Edit_Cut_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuStrip_Edit_Cut.Click
        RTB.ExecCut()
    End Sub
    Private Sub MenuStrip_Edit_Copy_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuStrip_Edit_Copy.Click
        RTB.ExecCopy()
    End Sub
    Private Sub MenuStrip_Edit_Paste_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuStrip_Edit_Paste.Click
        RTB.ExecPaste()
    End Sub
    Private Sub MenuStrip_Edit_Delete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuStrip_Edit_Delete.Click
        RTB.ExecDelete()
    End Sub
    Private Sub MenuStrip_Edit_SelectAll_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuStrip_Edit_SelectAll.Click
        RTB.SelectAll()
    End Sub
    Private Sub MenuStrip_Edit_Find_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuStrip_Edit_Find.Click
        Editor_Find()
    End Sub
    Private Sub MenuStrip_Edit_Replace_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuStrip_Edit_Replace.Click
        Editor_FindReplace()
    End Sub

    ' ===============================================================================================================
    '  FIND - REPLACE and Options
    ' ===============================================================================================================
    Friend Sub Editor_Find()
        If RTB.SelectedText = "" Then RTB.SelectCompleteWord_Short()
        With Form_FindReplace
            .OwnerCodeBox = RTB
            .InitFindText()
            .TopMost = True
            .DialogType = Form_FindReplace.DialogTypeValue.Find
            .Show()
            .txtFind.Focus()
        End With
    End Sub
    Friend Sub Editor_FindReplace()
        If RTB.SelectedText = "" Then RTB.SelectCompleteWord_Short()
        With Form_FindReplace
            .OwnerCodeBox = RTB
            .InitFindText()
            .TopMost = True
            .DialogType = Form_FindReplace.DialogTypeValue.Replace
            .Show()
            .txtFind.Focus()
        End With
    End Sub


    Private Sub Form1_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles Me.KeyDown
        ' ------------------------------------------------------------- CUT / COPY / PASTE
        If My.Computer.Keyboard.CtrlKeyDown Then
            RTB_Lines = RTB.Lines
            e.SuppressKeyPress = True
            e.Handled = True
            Select Case e.KeyCode
                Case Keys.F : Editor_Find()
                Case Keys.R : Editor_FindReplace()
                Case Keys.X : RTB.ExecCut()
                Case Keys.C : RTB.ExecCopy()
                Case Keys.V : RTB.ExecPaste()
                Case Keys.Z : RTB.ExecUndo()
                Case Keys.Y : RTB.ExecRedo()
                Case Else
                    e.Handled = False
                    e.SuppressKeyPress = False
            End Select
        End If
    End Sub

    Private Sub Form1_KeyUp(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles Me.KeyUp
        RTB.Focus()
    End Sub

    Private Sub RTB_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles RTB.TextChanged
        If Not EventsAreEnabled Then Return
        SaveCommandsFile()
        RTB_Lines = RTB.Lines
        ReinitTransferLists(RTB_Lines)
    End Sub

    Private Sub tbar_Zoom_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tkbar_Zoom.ValueChanged
        If Not EventsAreEnabled Then Return
        Static oldvalue As Int32 = -99
        Dim newvalue As Int32 = tkbar_Zoom.Value
        If newvalue = oldvalue Then Return
        oldvalue = newvalue
        ApplyEditorProps(True)
        Save_INI()
    End Sub

    Friend Sub ApplyEditorProps(Optional ByVal ForceNewZoom As Boolean = False)
        Dim z As Int32 = tkbar_Zoom.Value + 3
        Dim NewRtbZoom As Single = z / 11.0F
        If NewRtbZoom <> RTB.ZoomFactor Then
            If ForceNewZoom Then
                RTB.ZoomFactor = 0.1
            End If
            RTB.ZoomFactor = NewRtbZoom
            RTB.Refresh()
        End If
    End Sub

    Private Sub tbar_Zoom_KeyUp(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles tkbar_Zoom.KeyUp
        tkbar_Zoom.Focus()
    End Sub

    Private Sub tkbar_Transparency_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tkbar_Transparency.ValueChanged
        If Not EventsAreEnabled Then Return
        SetFormOpacity()
        tkbar_Transparency.Refresh()
        Save_INI()
    End Sub

    Private Sub SetFormOpacity()
        Me.Opacity = 1 - tkbar_Transparency.Value / 20.0F
    End Sub

End Class
