﻿'Imports System.Text.RegularExpressions

Public Class Form_FindReplace

    Private Sub Form_Replace_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        With Form1
            Me.Left = CInt(.Right - Me.Width - 100)
            Me.Top = CInt(.Top + .Height / 2 - Me.Height / 2)
        End With
    End Sub

    Private Sub Form_Replace_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        Me.Hide()
        e.Cancel = True
    End Sub

    Private Sub Form_Replace_VisibleChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.VisibleChanged
        If Me.Visible Then
            If m_CodeBox.SelectedText <> "" Then
                txtFind.Text = m_CodeBox.SelectedText
            End If
        End If
    End Sub

    Private Sub Form_Replace_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles Me.KeyDown
        If e.KeyCode = Keys.F3 Then
            FindText()
        End If
    End Sub

    Private Sub txtFind_KeyUp(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles txtFind.KeyUp
        If e.KeyCode = Keys.Enter Then
            FindText()
        End If
    End Sub

    Private Sub txtFind_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtFind.TextChanged
        Dim en As Boolean = txtFind.Text <> ""
        cmdFind.Enabled = en
        cmdReplace.Enabled = en
        cmdReplaceAll.Enabled = en
    End Sub

    Private Sub chkOnlyInErrorLines_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chk_OnlyInErrorLines.CheckedChanged
        UpdateForm()
    End Sub

    Private Sub cmdFind_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdFind.Click
        FindText()
    End Sub

    Private Sub cmdReplace_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdReplace.Click
        ExecReplace()
    End Sub

    Private Sub cmdReplaceAll_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdReplaceAll.Click
        ExecReplaceAll()
    End Sub

    Friend Sub InitFindText()
        If m_CodeBox.SelectedText <> "" Then
            txtFind.Text = m_CodeBox.SelectedText
        End If
    End Sub

    '=====================================================================================
    ' VARIABLES
    '=====================================================================================
    Private FindStartPosition As Integer
    Private m_CodeBox As SyntaxRichTextBox
    Private m_DialogType As DialogTypeValue = DialogTypeValue.Find

    Friend Enum DialogTypeValue
        Find = 0
        Replace = 1
    End Enum

    '=====================================================================================
    ' PROPERTIES
    '=====================================================================================
    Friend Property DialogType() As DialogTypeValue
        Get
            Return m_DialogType
        End Get
        Set(ByVal Value As DialogTypeValue)
            m_DialogType = Value
            UpdateForm()
        End Set
    End Property

    Friend WriteOnly Property OwnerCodeBox() As SyntaxRichTextBox
        Set(ByVal Value As SyntaxRichTextBox)
            m_CodeBox = Value
        End Set
    End Property

    '=====================================================================================
    ' HELPER ROUTINES
    '=====================================================================================
    Private Sub UpdateForm()
        If m_DialogType = DialogTypeValue.Find Then
            Me.Text = " Find"
            lblReplace.Visible = False
            txtReplace.Visible = False
            cmdReplace.Visible = False
            cmdReplaceAll.Visible = False
            chk_OnlyInErrorLines.Visible = False
            chk_OnlyInSelection.Visible = False
        Else
            Me.Text = " Replace"
            lblReplace.Visible = True
            txtReplace.Visible = True
            cmdReplace.Visible = True
            cmdReplaceAll.Visible = True
            chk_OnlyInErrorLines.Visible = True
            chk_OnlyInSelection.Visible = Not chk_OnlyInErrorLines.Checked
        End If
    End Sub

    '=====================================================================================
    ' FIND
    '=====================================================================================
    Private Sub FindText()
        Dim FoundAt As Integer
        FindStartPosition = m_CodeBox.SelectionStart + 1
        FoundAt = Find_WithOptions(m_CodeBox.Text, _
                                   FindStartPosition, _
                                   txtFind.Text, _
                                   chk_MatchCase.Checked, _
                                   chk_WholeWord.Checked)
        '
        If FoundAt > 0 Then
            m_CodeBox.ScrollToCenterLine(m_CodeBox.GetLineFromCharIndex(FoundAt))
            m_CodeBox.Select(FoundAt, txtFind.Text.Length)
            Return
        End If

        Beep()
        m_CodeBox.Select(0, 0)

        FindStartPosition = m_CodeBox.SelectionStart + 1
        FoundAt = Find_WithOptions(m_CodeBox.Text, _
                                   FindStartPosition, _
                                   txtFind.Text, _
                                   chk_MatchCase.Checked, _
                                   chk_WholeWord.Checked)
        If FoundAt > 0 Then
            m_CodeBox.ScrollToCenterLine(m_CodeBox.GetLineFromCharIndex(FoundAt))
            m_CodeBox.Select(FoundAt, txtFind.Text.Length)
        End If

    End Sub


    '=====================================================================================
    ' REPLACE and REPLACE-ALL
    '=====================================================================================
    Private Sub ExecReplace()
        Dim StartAt As Integer = m_CodeBox.SelectionStart
        If m_CodeBox.SelectedText = "" Then Return
        m_CodeBox.SelectedText = Replace_WithOptions(m_CodeBox.SelectedText, _
                                                     txtFind.Text, _
                                                     txtReplace.Text, _
                                                     chk_MatchCase.Checked, _
                                                     chk_WholeWord.Checked)

        'Form1.RTB.ColorAllLines()
        Form1.RTB.ColorSelectedLine()
        m_CodeBox.Select(StartAt, txtReplace.Text.Length)
        m_CodeBox.UndoAndHistory_AddEntry()
    End Sub

    Private Sub ExecReplaceAll()
        Dim StartAt As Integer = m_CodeBox.SelectionStart
        '
        If chk_OnlyInErrorLines.Checked Then
            ' --------------------------------------------------------------------- Replace only in error lines
            RTB_Lines = Form1.RTB.Lines
            For i As Int32 = 0 To RTB_Lines.Length - 1
                If RTB_Lines(i).Contains(txtFind.Text) Then
                    m_CodeBox.SelectLine(i)
                    If Form1.RTB.IsErrorOrWarningColor(m_CodeBox.SelectionBackColor) Then
                        If m_CodeBox.SelectedText = "" Then Return
                        m_CodeBox.SelectedText = Replace_WithOptions(m_CodeBox.SelectedText, _
                                                                     txtFind.Text, _
                                                                     txtReplace.Text, _
                                                                     chk_MatchCase.Checked, _
                                                                     chk_WholeWord.Checked)
                    End If
                End If
            Next
        Else
            ' -------------------------------------------------------------------- Replace only in selection or replace all
            If chk_OnlyInSelection.Checked Then
                If m_CodeBox.SelectedText = "" Then Return
                m_CodeBox.SelectedText = Replace_WithOptions(m_CodeBox.SelectedText, _
                                                             txtFind.Text, _
                                                             txtReplace.Text, _
                                                             chk_MatchCase.Checked, _
                                                             chk_WholeWord.Checked)
            Else
                m_CodeBox.Text = Replace_WithOptions(m_CodeBox.Text, _
                                                     txtFind.Text, _
                                                     txtReplace.Text, _
                                                     chk_MatchCase.Checked, _
                                                     chk_WholeWord.Checked)
            End If
        End If
        '
        Form1.RTB.ColorAllLines()
        '
        m_CodeBox.SelectionStart = StartAt
        m_CodeBox.UndoAndHistory_AddEntry()
    End Sub

    Private Sub cmdClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdClose.Click
        Me.Hide()
    End Sub

    '=====================================================================================
    ' FIND with IgnoreCase and WholeWord options
    '=====================================================================================
    Private Function Find_WithOptions(ByVal Text As String, _
                                     ByVal StartPosition As Int32, _
                                     ByVal WordToFind As String, _
                                     ByVal MatchCase As Boolean, _
                                     ByVal TestWholeWord As Boolean) As Int32
        '
        If Text Is Nothing Then Return -1
        If Text Is "" Then Return -1
        '
        Dim FoundAt As Int32
        Do
            ' The InStr function is 1 based, so we correct with StartPosition +1 and the final -1 
            FoundAt = InStr(StartPosition + 1, _
                            Text, _
                            WordToFind, _
                            If(MatchCase, CompareMethod.Binary, CompareMethod.Text)) - 1
            '
            If FoundAt < 0 Then Exit Do
            If Not TestWholeWord Then Exit Do
            ' ---------------------------------------------------------------------------------- this part executes the WholeWord option
            If IsWholeWord(Text, FoundAt, WordToFind) Then
                Exit Do
            Else
                StartPosition = FoundAt + 1
                FoundAt = -1
            End If
            ' ---------------------------------------------------------------------------------------------------------------------------
        Loop
        '
        Return FoundAt
    End Function

    Friend Function IsWholeWord(ByVal Text As String, _
                                ByVal Position As Int32, _
                                ByVal Word As String) As Boolean
        '
        Static WordChars As String = "ABCDEFGHIJKLMNOPQRSTUVWYXZabcdefghijklmnopqrstuvwyxz0123456789_-@"
        '
        If (Position <= 0 OrElse Not WordChars.Contains(Text(Position - 1))) AndAlso _
           (Position + Len(Word) >= Text.Length OrElse Not WordChars.Contains(Text(Position + Len(Word)))) Then
            Return True
        Else
            Return False
        End If
    End Function


    '=====================================================================================
    ' REPLACE with IgnoreCase and WholeWord options
    '=====================================================================================
    ' This function needs: Imports System.Text.RegularExpressions
    ' ------------------------------------------------------------------------------------
    Private Function Replace_WithOptions(ByVal Text As String, _
                                         ByVal WordToFind As String, _
                                         ByVal Replacement As String, _
                                         ByVal MatchCase As Boolean, _
                                         ByVal WholeWord As Boolean) As String
        '
        If Text Is Nothing Then Return Nothing
        If Text Is "" Then Return ""
        '
        If WholeWord Then

            ' ------------------------------------------------------- not working with minus sign - replaced with the following
            'Return Regex.Replace(Text, _
            '                     "\b" + Regex.Escape(WordToFind) + "\b", _
            '                     Replacement, _
            '                     If(MatchCase, RegexOptions.None, RegexOptions.IgnoreCase))


            ' ------------------------------------------------------- replaced with this (3 sec for 2000 lines)
            'WordToFind = WordToFind.Replace("-", "_minussign_")
            'Replacement = Replacement.Replace("-", "_minussign_")
            'Text = Text.Replace("-", "_minussign_")
            'Text = Regex.Replace(Text, _
            '                     "\b" + Regex.Escape(WordToFind) + "\b", _
            '                     Replacement, _
            '                     If(MatchCase, RegexOptions.None, RegexOptions.IgnoreCase))
            'Text = Text.Replace("_minussign_", "-")
            'Return Text

            ' ------------------------------------------------------- replaced with this (3 sec for 2000 lines) (better control on WordChars)
            If MatchCase Then
                Return ReplaceWholeWord(Text, WordToFind, Replacement)
            Else
                Return ReplaceWholeWord_CaseInsensitive(Text, WordToFind, Replacement)
            End If

        Else
            Return Replace(Text, _
                           WordToFind, _
                           Replacement, , , _
                           If(MatchCase, CompareMethod.Binary, CompareMethod.Text))
        End If
    End Function


    '=====================================================================================
    ' REPLACE WHOLE WORD - WITHOUT RegExp
    '=====================================================================================
    Friend Function IsWordChar(ByVal c As Char) As Boolean
        Static WordChars As String = "ABCDEFGHIJKLMNOPQRSTUVWYXZabcdefghijklmnopqrstuvwyxz0123456789_-@"
        Return WordChars.Contains(c)
    End Function

    Public Function ReplaceWholeWord(ByVal Text As String, ByVal WordToFind As String, ByVal Replacement As String) As String
        Dim firstLetter As Char = WordToFind(0)
        Dim sb As System.Text.StringBuilder = New System.Text.StringBuilder
        Dim previousWasLetterOrDigit As Boolean = False
        Dim i As Integer = 0
        '
        While i < Text.Length - WordToFind.Length + 1
            Dim wordFound As Boolean = False
            Dim c As Char = Text(i)
            If c = firstLetter Then
                If Not previousWasLetterOrDigit Then
                    If Text.Substring(i, WordToFind.Length) = WordToFind Then
                        wordFound = True
                        Dim wholeWordFound As Boolean = True
                        If Text.Length > i + WordToFind.Length Then
                            If IsWordChar(Text(i + WordToFind.Length)) Then
                                wholeWordFound = False
                            End If
                        End If
                        ' 
                        If wholeWordFound Then
                            sb.Append(Replacement)
                        Else
                            sb.Append(WordToFind)
                        End If
                        ' 
                        i = i + WordToFind.Length
                    End If
                End If
            End If
            '
            If Not wordFound Then
                previousWasLetterOrDigit = IsWordChar(c)
                sb.Append(c)
                i = i + 1
            End If
        End While
        '
        If Text.Length - i > 0 Then
            sb.Append(Text.Substring(i))
        End If
        '
        Return sb.ToString
    End Function

    Public Function ReplaceWholeWord_CaseInsensitive(ByVal Text As String, ByVal WordToFind As String, ByVal Replacement As String) As String
        Dim WordToFind_Lcase As String = WordToFind.ToLower
        Dim firstLetter As Char = WordToFind_Lcase(0)
        Dim sb As System.Text.StringBuilder = New System.Text.StringBuilder
        Dim previousWasLetterOrDigit As Boolean = False
        Dim i As Integer = 0
        '
        While i < Text.Length - WordToFind.Length + 1
            Dim wordFound As Boolean = False
            Dim c As Char = Text(i)
            If Char.ToLower(c) = firstLetter Then
                If Not previousWasLetterOrDigit Then
                    If Text.Substring(i, WordToFind.Length).ToLower = WordToFind_Lcase Then
                        wordFound = True
                        Dim wholeWordFound As Boolean = True
                        If Text.Length > i + WordToFind.Length Then
                            If IsWordChar(Text(i + WordToFind.Length)) Then
                                wholeWordFound = False
                            End If
                        End If
                        ' 
                        If wholeWordFound Then
                            sb.Append(Replacement)
                        Else
                            sb.Append(Text.Substring(i, WordToFind.Length))
                        End If
                        ' 
                        i = i + WordToFind.Length
                    End If
                End If
            End If
            '
            If Not wordFound Then
                previousWasLetterOrDigit = IsWordChar(c)
                sb.Append(c)
                i = i + 1
            End If
        End While
        '
        If Text.Length - i > 0 Then
            sb.Append(Text.Substring(i))
        End If
        '
        Return sb.ToString
    End Function

End Class